#
# RPM spec file, initially written by Ben Webb.
#
# $Id: mpiexec.spec.in 347 2006-03-17 20:03:48Z pw $
#
# Copyright (C) 2002-6 Pete Wyckoff <pw@osc.edu>
#

Name:          mpiexec
Version:       0.84
%define prefixdir /usr/local/mpiexec/%{version}/%{_target_cpu}
%{!?modulefile_path: %define modulefile_path /usr/local/share/Modules/modulefiles/%{name}}
Release:       1%{?dist}
License:       GPL
Summary:       MPI job launcher that uses the PBS task interface directly
Vendor:        Pete Wyckoff <pw@osc.edu>
URL:           http://www.osc.edu/~pw/mpiexec/
Group:         Applications/Engineering and Scientific
Source0:       https://www.osc.edu/~djohnson/mpiexec/%{name}-%{version}.tgz
Patch1:        mpiexec.patch
BuildRoot:     %{_tmppath}/%{name}-%{version}
BuildRequires: torque-devel

%description
Mpiexec gathers node settings from PBS, prepares for the MPI library run
environment, and starts tasks through the PBS task manager interface.
Attempts to duplicate mpirun as much as possible, while getting everything
correct, and being faster than rsh.  As a side effect, PBS maintains
proper accounting of all tasks of a parallel job, and can terminate
everything on job abort.

%prep
%setup -q
%patch1 -p1

#
# The default PBS location is --with-pbs=/usr/local/pbs
# You may want to change it for your actual PBS install path.
#
# If (and only if) using PBSPro, be sure to add --enable-pbspro-helper.
#
# The default MPI library type is GM, but you can change that here.
# You can override it at runtime, too, with, e.g. "--comm=ib".
#
%build
./configure --prefix=%{prefixdir} --with-pbs --with-default-comm=mpich-ib

# remove $RPM_BUILD_ROOT in mpiexec
perl -pi -e "s|$RPM_BUILD_ROOT||g" config.h

make

%install
make DESTDIR=${RPM_BUILD_ROOT} install

mkdir -p $RPM_BUILD_ROOT%{modulefile_path}/%{version}
cat <<EOF >$RPM_BUILD_ROOT/%{modulefile_path}/%{version}/%{__isa_bits}
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# MPIEXEC RPM).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds MPIEXEC %{version} to various paths"
}

module-whatis   "Sets up MPIEXEC %{version} in your environment"

prepend-path PATH "%{prefixdir}/bin"
prepend-path MANPATH "%{prefixdir}/man"
EOF

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%{prefixdir}
%dir %{modulefile_path}
%dir %{modulefile_path}/%{version}
%{modulefile_path}/%{version}/%{__isa_bits}

%changelog
* Thu Nov 22 2012 Josko Plazonic <plazonic@math.princeton.edu>
- add a recent patch and build it for the first time

* Fri Mar 17 2006 Pete Wyckoff <pw@osc.edu>
- Auto-generate as part of build to get version.

* Thu Dec 22 2005 Pete Wyckoff <pw@osc.edu> 0.80-2
- Add default comm explicitly, cleanup.

* Fri Mar 19 2004 Pete Wyckoff <pw@osc.edu>
- Update version, remove old-time flag.

* Mon May 27 2002 Ben Webb <ben@bellatrix.pcl.ox.ac.uk>
- Initial build, with mpiexec CVS, and spec file based on our own
  site-specific one
